<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>postmarketOS // binary repo status</title>
    <link rel="stylesheet" href="static/style.css">
    <link rel="shortcut icon" href="static/favicon.ico">
</head>
<body>
<header class="header">
    <a class="logo" name="^" href="/">
        <img src="static/logo.svg">
        <span>postmarketOS</span>
    </a>
    <div class="badge">
        <!-- Copy of currently used badge is at: /badge.svg. Avoid caching
             issues by using the badge name here. -->
        <img src="static/badges/{{badge_name}}.svg">
    </div>
    <span class="nav header-bottom">
        <a href="https://postmarketos.org">about</a>
        <a href="https://pkgs.postmarketos.org">package search</a>
        <a href="https://gitlab.postmarketos.org/postmarketOS/pmaports">build recipes</a>
        <a href="https://images.postmarketos.org/bpo/">images</a>
    </span>
    <span class="powered-by header-bottom">powered by
        <a href="https://sourcehut.org/">
            sourcehut
            <span class="sourcehut-builds">builds</span>
        </a>
    </span>
</header>
<main class="main">
    <a class="h" name="toc" href="#toc">Overview</a><br>
    <div class="toc-grid">
        <div class="toc-grid-pkgs">
            <a class="h3" name="pkgs" href="#pkgs">Packages</a><br>
            <table class="toc">
                <tr>
                    <td>{{ len(pkgs.building) }}</td>
                    <td><a href="#building-pkgs">
                        building</a></td>
                </tr>
                <tr>
                    <td>{{ len(pkgs.failed) }}</td>
                    <td><a href="#failed-pkgs">failed</a></td>
                </tr>
                <tr>
                    <td>{{ len(pkgs.queued) }}</td>
                    <td><a href="#queued-pkgs">queued</a></td>
                </tr>
                <tr>
                    <td>{{ len(pkgs.built) }}</td>
                    <td><a href="#built-pkgs">built</a></td>
                </tr>
                <tr>
                    <td>{{ len(pkgs.published) }}</td>
                    <td><a href="#published-pkgs">
                        published</a></td>
                </tr>
                <tr>
                    <td>{{ pkgcount }}</td>
                    <td>total (all time)</td>
                </tr>
            </table>
        </div>
        <div class="toc-grid-imgs">
            <a class="h3" name="imgs" href="#imgs">Images</a><br>
            <table class="toc">
                <tr>
                    <td>{{ imgs.building.count() }}</td>
                    <td><a href="#building-imgs">
                        building</a></td>
                </tr>
                <tr>
                    <td>{{ imgs.failed.count() }}</td>
                    <td><a href="#failed-imgs">failed</a></td>
                </tr>
                <tr>
                    <td>{{ imgs.queued.count() }}</td>
                    <td><a href="#queued-imgs">queued</a></td>
                </tr>
                <tr>
                    <td>{{ imgs.published.count() }}</td>
                    <td><a href="#published-imgs">
                        published</a></td>
                </tr>
                <tr>
                    <td>{{ imgcount }}</td>
                    <td>total (all time)</td>
                </tr>
            </table>
        </div>
    </div>
    <br>
    <a class="h3" name="branches" href="#branches">Branches</a><br>
    <ul>
        {% for branch, branch_data in bpo.repo.staging.get_branches_with_staging().items() %}
        <li> <span class="branch">{{branch}}</span> ({%for arch in branch_data["arches"]
            %}<span class="arch">{{ arch }}</span>{{
            ", " if not loop.last
            }}{%endfor%})
            {% if branch_data.get("ignore_errors") %}
            (WIP)
            {% endif %}

        {% endfor %}
    </ul>

    <a class="h" name="log" href="#log">Log</a>
    <div class="log">
        {% for day,log_entries in log_entries_days.items() %}
        <a class="h3" name="{{ day }}" href="#{{ day }}">{{ day }}</a>
        <ul>
            {% for entry in log_entries %}
            <li> <span class="time">{{ entry.date.strftime("%H:%M:%S") }}</span>
            {% if entry.branch
            %}<span class="branch">{{ entry.branch }}{% if entry.splitrepo
                %}:{{ entry.splitrepo }}{% endif %}</span>{%
            endif %}{#

            * package related properties *
            #}{% if entry.arch
            %}/<span class="arch">{{ entry.arch }}</span>{%
            endif %}{% if entry.pkgname
            %}/<span class="pkgname">{{ entry.pkgname }}</span>{%
            endif %}{% if entry.version
            %}-<span class="version">{{ entry.version }}</span>{%
            endif %}{#

            * image related properties *
            #}{% if entry.device
            %}:<span class="device">{{ entry.device }}</span>{%
            endif %}{% if entry.ui
            %}:<span class="ui">{{ entry.ui }}</span>{%
            endif %}

            {% if entry.action == "restart" %}
            build.postmarketos.org server restart initiated, doing
            integrity checks...
            {% elif entry.action == "restart_done" %}
            build.postmarketos.org server restart completed{#

            * package related actions *
            #}{% elif entry.action == "api_push_hook_gitlab" %}
            new commit(s) pushed to pmaports.git
            {% elif entry.action == "delete_staging_repo" %}
            staging repository removed (git branch removed)
            {% elif entry.action == "job_get_depends" %}
            calculating missing binary packages
            {% elif entry.action == "api_job_callback_get_depends" %}
            updated the database from current pmaports <i>(main and split repos, if any)</i>
            {% elif entry.action == "job_build_package" %}
            building package
                {% if entry.retry_count %}
                (try {{entry.retry_count + 1}}/{{bpo.config.const.retry_count_max + 1}})
                {% endif %}
            {% elif entry.action in ["api_job_callback_build_package", "package_built"] %}
            package built
            {% elif entry.action == "job_sign_index" %}
            signing the package index
            {% elif entry.action == "api_job_callback_sign_index" %}
            publishing to mirror
            {% elif entry.action == "job_update_package_status_built" %}
            package built
            {% elif entry.action == "job_update_package_status_failed" %}
            <b>build failed</b>
            (try {{entry.retry_count + 1}}/{{bpo.config.const.retry_count_max + 1}})
            {% elif entry.action == "build_repo_stuck" %}
            <b>repo is stuck</b> - fix failed builds to continue
            {% elif entry.action == "package_removed_from_pmaports" %}
            removed from pmaports.git
            {% elif entry.action == "package_exists_in_wip_repo" %}
            package exists in WIP repo already, build skipped
            {% elif entry.action == "package_published" %}
            package published
            {% elif entry.action == "obsolete_wip_package" %}
            does not exist in pmaports.git anymore, removing from
            WIP repo
            {% elif entry.action == "missing_built_apk" %}
            not found in WIP repo on disk, although status was set
            to "built" in the DB -&gt; changing back to "queued"
            {% elif entry.action == "missing_published_apk" %}
            not found in final repo on disk, although status was
            set to "published" in the DB -&gt; changing back to
            "built"
            {% elif entry.action == "remove_broken_apk" %}
            <b>broken package, removing</b>
            (<a href="https://gitlab.postmarketos.org/postmarketOS/build.postmarketos.org/issues/56">#56</a>)
            {% elif entry.action == "remove_broken_apk_reset_deleted" %}
            changing status back to "queued" after apk was removed
            {% elif entry.action == "remove_broken_apk_reset_failed" %}
            changing status back from "failed" to "queued", because
            the broken apk of a dependency was removed
            {% elif entry.action == "api_push_reset_failed" %}
            changing status back to "queued"
            <small>(modified in {{ commit_link(entry.commit)|safe
                }})</small>
            {% elif entry.action == "api_push_reset_failed_depend" %}
            changing status back to "queued"
            <small>(dependency "{{ entry.depend_pkgname }}"
                modified in {{ commit_link(entry.commit)|safe
                }})</small>
            {% elif entry.action == "init_staging_repo" %}
            initialized new staging repository
            {% elif entry.action == "sync_with_orig_repo" %}
            synced {{ entry.count }} package(s) from original repository
            {#

            * image related actions *
            #}{% elif entry.action == "add_image_to_queue" %}
            image queued
            {% elif entry.action == "job_build_image" %}
            building
            {% elif entry.action == "job_update_image_status_failed" %}
            <b>build failed</b>
            (try {{entry.retry_count + 1
                }}/{{bpo.config.const.retry_count_max + 1}})
            {% elif entry.action == "api_job_callback_build_image" %}
            built and published
            {% elif entry.action == "image_removed_from_config" %}
            removed from config
            {% elif entry.action == "remove_old_image" %}
            remove old image dir {{ entry.dir_name }}
            {#

            * repo_bootstrap related actions *
            #}{% elif entry.action == "repo_bootstrap_add" %}
            queued
            {% elif entry.action == "job_repo_bootstrap" %}
            building
            {% elif entry.action == "job_update_repo_bootstrap_status_built" %}
            built
            {% elif entry.action == "job_update_repo_bootstrap_status_failed" %}
            <b>failed</b>
            (try {{entry.retry_count + 1
                }}/{{bpo.config.const.retry_count_max + 1}})
            {% elif entry.action == "repo_bootstrap_published" %}
            published
            {#

            * other actions *
            #}{% elif entry.action == "bug_found_shutting_down" %}
            bpo seems to have hit a bug, shutting down
            {#

            * unknown action *
            #}{% else %}
            (unknown action: {{ entry.action }})
            {% endif %}
            <!-- action: {{ entry.action }} -->
            {% if entry.job_id %}
            <a class="job-log" href="{{ bpo.helpers.job.get_link(entry.job_id) }}">[log]</a>
            {% endif %}
            {% if entry.dir_name and
                entry.action != 'remove_old_image' and
                entry.ui and
                entry.device and
                entry.branch %}
            <a class="img-dir" href="{{
                bpo.images.url_db_obj(entry)
                }}">[dir]</a>
            {% endif %}
            {% endfor %}
        </ul>
        {% endfor %}
    </div>

    <a class="h" name="building" href="#building">Building</a><br>
    {% if len(pkgs.building) %}
    <a class="h3" name="building-pkgs" href="#building-pkgs">
        Packages ({{ len(pkgs.building) }})
    </a>
    <ul>
        {% for package in pkgs.building %}
        <li> <span class="branch">{{package.branch}}{% if package.splitrepo
                %}:{{package.splitrepo}}{% endif %}</span>/<span
            class="arch">{{package.arch}}</span>/<span
            class="pkgname">{{package.pkgname}}</span>{%
                if package.version %}-<span class="version">{{package.version}}</span>{% endif %}
            <a class="job-log" href="{{ bpo.helpers.job.get_link(package.job_id) }}">[log]</a>
        {% endfor %}
    </ul>
    {% endif %}
    {% if imgs.building.count() %}
    <a class="h3" name="building-imgs" href="#building-imgs">
        Images ({{ imgs.building.count() }})
    </a>
    <ul>
        {% for img in imgs.building %}
        <li> <span class="branch">{{img.branch}}</span>:<span
            class="device">{{img.device}}</span>:<span
            class="ui">{{img.ui}}</span>
            <a class="job-log" href="{{ bpo.helpers.job.get_link(img.job_id) }}">[log]</a>
        {% endfor %}
    </ul>
    {% endif %}

    <a class="h" name="failed" href="#failed">Failed</a><br>
    {% if len(pkgs.failed) %}
    <a class="h3" name="failed-pkgs" href="#failed-pkgs">
        Packages ({{ len(pkgs.failed) }})
    </a>
    <ul>
        {% for package in pkgs.failed %}
        <li> <span class="branch">{{package.branch}}{% if package.splitrepo
                %}:{{package.splitrepo}}{% endif %}</span>/<span
            class="arch">{{package.arch}}</span>/<span
            class="pkgname">{{package.pkgname}}</span>{%
                if package.version %}-<span class="version">{{package.version}}</span>{% endif %}
            (try {{package.retry_count + 1}}/{{bpo.config.const.retry_count_max + 1}})
            <a class="job-log" href="{{ bpo.helpers.job.get_link(package.job_id) }}">[log]</a>
        {% endfor %}
    </ul>
    {% endif %}
    {% if imgs.failed.count() %}
    <a class="h3" name="failed-imgs" href="#failed-imgs">
        Images ({{ imgs.failed.count() }})
    </a>
    <ul>
        {% for img in imgs.failed %}
        <li> <span class="branch">{{img.branch}}</span>:<span
            class="device">{{img.device}}</span>:<span
            class="ui">{{img.ui}}</span>
            <a class="job-log" href="{{ bpo.helpers.job.get_link(img.job_id) }}">[log]</a>
        {% endfor %}
    </ul>
    {% endif %}

    <a class="h" name="queued" href="#queued">Queued</a><br>
    {% if len(pkgs.queued) %}
    <a class="h3" name="queued-pkgs" href="#queued-pkgs">
        Packages ({{ len(pkgs.queued) }})
    </a>
    <ul>
        {% for package in pkgs.queued %}
        <li> <span class="branch">{{package.branch}}{% if package.splitrepo
                %}:{{package.splitrepo}}{% endif %}</span>/<span
            class="arch">{{package.arch}}</span>/<span
            class="pkgname">{{package.pkgname}}</span>{%
                if package.version %}-<span class="version">{{package.version}}</span>{% endif %}
            {% if not package.depends_built() %}
            (missing depends:
            {% for depend in package.depends_missing_list()
            %}{{depend.pkgname}}{{", " if not loop.last}}{%
            endfor %})
            {% endif %}
        {% endfor %}
    </ul>
    {% endif %}
    {% if imgs.queued.count() %}
    <a class="h3" name="queued-imgs" href="#queued-imgs">
        Images ({{ imgs.queued.count() }})
    </a>
    <ul>
        {% for img in imgs.queued %}
        <li> <span class="branch">{{img.branch}}</span>:<span
            class="device">{{img.device}}</span>:<span
            class="ui">{{img.ui}}</span>
            <a class="job-log" href="{{ bpo.helpers.job.get_link(img.job_id) }}">[log]</a>
        {% endfor %}
    </ul>
    {% endif %}

    <a class="h" name="built" href="#built">Built</a><br>
    {% if len(pkgs.built) %}
    <a class="h3" name="built-pkgs" href="#built-pkgs">
        Packages ({{ len(pkgs.built) }})
    </a>
    <ul>
        {% for package in pkgs.built %}
            {% if package.job_id %}
        <li> <span class="branch">{{package.branch}}{% if package.splitrepo
                %}:{{package.splitrepo}}{% endif %}</span>/<span
            class="arch">{{package.arch}}</span>/<span
            class="pkgname">{{package.pkgname}}</span>{%
                if package.version %}-<span class="version">{{package.version}}</span>{% endif %}
            <a class="job-log" href="{{ bpo.helpers.job.get_link(package.job_id) }}">[log]</a>
            {% endif %}
        {% endfor %}
        {% for branch in pkgs.built_synced %}
            {% for arch in pkgs.built_synced[branch] %}
        <li> <span class="branch">{{branch}}</span>/<span
            class="arch">{{arch}}</span> synced {{pkgs.built_synced[branch][arch]}}
            package(s) from original repository
            {% endfor %}
        {% endfor %}
    </ul>
    {% endif %}

    <a class="h" name="published" href="#published">Published</a><br>
    {% if len(pkgs.published) %}
    <a class="h3" name="published-pkgs" href="#published-pkgs">
        Packages ({{ len(pkgs.published) }})
    </a>
    <ul>
        {% for package in pkgs.published %}
            {% if package.job_id %}
        <li> <span class="branch">{{package.branch}}{% if package.splitrepo
                %}:{{package.splitrepo}}{% endif %}</span>/<span
            class="arch">{{package.arch}}</span>/<span
            class="pkgname">{{package.pkgname}}</span>{%
                if package.version %}-<span class="version">{{package.version}}</span>{% endif %}
            <a class="job-log" href="{{ bpo.helpers.job.get_link(package.job_id) }}">[log]</a>
            {% endif %}
        {% endfor %}
        {% for branch in pkgs.published_synced %}
            {% for arch in pkgs.published_synced[branch] %}
        <li> <span class="branch">{{branch}}</span>/<span
            class="arch">{{arch}}</span> synced {{pkgs.published_synced[branch][arch]}}
            package(s) from original repository
            {% endfor %}
        {% endfor %}
    </ul>
    {% endif %}
    {% if imgs.published.count() %}
    <a class="h3" name="published-imgs" href="#published-imgs">
        Images ({{ imgs.published.count() }})
    </a>
    <ul>
        {% for img in imgs.published %}
        <li> <span class="time">{{ img.dir_name }}</span>
            <span class="branch">{{img.branch}}</span>:<span
            class="device">{{img.device}}</span>:<span
            class="ui">{{img.ui}}</span>
            <a class="job-log" href="{{
                bpo.helpers.job.get_link(img.job_id)
                }}">[log]</a>
            <a class="img-dir" href="{{bpo.images.url_db_obj(img)
                }}">[dir]</a>
        {% endfor %}
    </ul>
    {% endif %}
    <a class="h" name="notes" href="#notes">Notes</a><br>
    <ul class="notes">
        <li> Failures on WIP branches are ignored for the top right status
             badge.
        <li> Packages listed under Built get published after there are no more
             Queued and Failed packages for the same arch and branch.
        <li> As images don't depend on other images, they just get published
             directly without passing through the Built status.
    </ul>
</main>
<footer>
    <div class="source">
        AGPL-3.0
        (<a href="https://gitlab.postmarketos.org/postmarketOS/build.postmarketos.org"
        >source</a>)
    </div>
    <div class="copyright">
        &copy; {{year}} postmarketOS contributors
    </div>
</footer>
</body>
</html>
